/*
*  TOPPERS/OSEK Kernel
*      Toyohashi Open Platform for Embedded Real-Time Systems/
*      OSEK Kernel
* 
*  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
*                              Toyohashi Univ. of Technology, JAPAN
*  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
*              Graduate School of Information Science, Nagoya Univ., JAPAN
*  Copyright (C) 2005-2006 by Witz Corporation, JAPAN
* 
*  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
*  ɂČ\Ă GNU General Public License  Version 2 ɋL
*  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
*  ς̂܂ށDȉjgpEEρEĔzziȉC
*  pƌĂԁj邱Ƃ𖳏ŋD
*  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
*      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
*      XR[hɊ܂܂Ă邱ƁD
*  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
*      pł`ōĔzzꍇɂ́CĔzzɔhLgip
*      ҃}jAȂǁjɁCL̒쌠\C̗pщL
*      ̖ۏ؋Kfڂ邱ƁD
*  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
*      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
*      ƁD
*    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
*        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
*    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
*        񍐂邱ƁD
*  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
*      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
* 
*  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
*  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
*  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
*  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
*/ 

/*
 *	^[QbgVXeˑW[ AZuꕔiSH2pj
 */


	.section ".text", "ax"

/*
 *	჌x̃^[QbgVXeˑ̏
 *
 *	X^[gAbvW[̒ŁCX^bŇɌĂяoD
 */
	.globl hardware_init_hook
/*
 * hardware_init_hook𖳌ɂꍇ͉L.equ `RgAEgC
 * ֐̋Lq폜邱ƁD
*/
hardware_init_hook:
#ifdef	USE_SRAM
	/*
	 *	CS1ԁA16rbgANZXAAT[ggȂ AEFCgTCN1
	 *  TCNԃAChȂAAANZXACh
	 */
	mov.w	bcr1_init , r0
	mov.l	bcr1_adr , r1
	mov.w	r0 , @r1
	mov.w	bcr2_init , r0
	mov.l	bcr2_adr , r1
	mov.w	r0 , @r1
	mov.w	wcr1_init , r0
	mov.l	wcr1_adr , r1
	mov.w	r0 , @r1
	mov.w	wcr2_init , r0
	mov.l	wcr2_adr , r1
	mov.w	r0 , @r1
	/* PFCݒ */
	mov.w	pacrh_init , r0
	mov.l	pacrh_adr , r1
	mov.w	r0 , @r1
	mov.w	pacrl1_init , r0
	mov.l	pacrl1_adr , r1
	mov.w	r0 , @r1
	mov.w	pccr_init , r0
	mov.l	pccr_adr , r1
	mov.w	r0 , @r1
	mov.w	pdcrl1_init , r0
	mov.l	pdcrl1_adr , r1
	mov.w	r0 , @r1
	mov.w	pdcrl2_init , r0
	mov.l	pdcrl2_adr , r1
	mov.w	r0 , @r1
	rts
	nop

bcr1_init:
	.word	0x500f
bcr2_init:
	.word	0xf3fd
wcr1_init:
	.word	0xff1f
wcr2_init:
	.word	0x000f
pacrh_init:
	.word	0x0000
pacrl1_init:
	.word	0x1540
pccr_init:
	.word	0xffff
pdcrl1_init:
	.word	0xffff
pdcrl2_init:
	.word	0x0000

.align	4
bcr1_adr:
	.long	0xffff8620
bcr2_adr:
	.long	0xffff8622
wcr1_adr:
	.long	0xffff8624
wcr2_adr:
	.long	0xffff8626
pacrh_adr:
	.long	0xffff8388
pacrl1_adr:
	.long	0xffff838c
pccr_adr:
	.long	0xffff839c
pdcrl1_adr:
	.long	0xffff83ac
pdcrl2_adr:
	.long	0xffff83ae

#else
.align	4
	.long 0 
#endif	/* USE_SRAM */


/*
 *	჌x̃\tgEFAˑ̏
 *
 *	X^[gAbvW[̒ŁC[UC֐ĂяȏO
 *	ĂяoD
 */
	.globl software_init_hook
/*
 *	software_init_hookLɂꍇ͉L.equ `RgC
 *	֐V{̃RgAEgƊ֐̋LqsƁD
 */
.align	4
software_init_hook:
	.long	0
/*software_init_hook:
 *	rts
 *	nop
 */
	.end
